<?php
class ControllerExtensionShippingInxpressShippingRates extends Controller {
	private $error = array();

	public function registered() {
		if (($this->request->server['REQUEST_METHOD'] == 'GET') && $this->validate()) {
		  $this->load->model('setting/setting');

			$params = array(
				'inxpress_shipping_store_id' => $this->request->get['store_id']
			);

			$this->model_setting_setting->editSetting('inxpress_shipping', $params);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/shipping/inxpress_shipping_rates', 'user_token=' . $this->session->data['user_token'], true));
		}
	}

	public function index() {
		$this->load->language('extension/shipping/inxpress_shipping_rates');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('shipping_inxpress_shipping_rates', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/shipping/inxpress_shipping_rates', 'user_token=' . $this->session->data['user_token'], true));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');

		$data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/shipping/inxpress_shipping_rates', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/shipping/inxpress_shipping_rates', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true);

		if (isset($this->request->post['shipping_inxpress_shipping_rates_tax_class_id'])) {
			$data['shipping_inxpress_shipping_rates_tax_class_id'] = $this->request->post['shipping_inxpress_shipping_rates_tax_class_id'];
		} else {
			$data['shipping_inxpress_shipping_rates_tax_class_id'] = $this->config->get('shipping_inxpress_shipping_rates_tax_class_id');
		}

		$this->load->model('localisation/tax_class');
		/**
		 * Tax classes are used in the case if you want to put any kind of tax on your shipping
		 */
		$data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

		if (isset($this->request->post['shipping_inxpress_shipping_rates_inxpress_account'])) {
			$data['shipping_inxpress_shipping_rates_inxpress_account'] = $this->request->post['shipping_inxpress_shipping_rates_inxpress_account'];
		} else {
			$data['shipping_inxpress_shipping_rates_inxpress_account'] = $this->config->get('shipping_inxpress_shipping_rates_inxpress_account');
		}

		$this->load->model('localisation/geo_zone');
		/**
		 * Geo zones are used in order to set in which zone(s) you want this shipping service to work
		 */
		$geo_zones = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['shipping_inxpress_shipping_rates_zone_all'])) {
			$data['shipping_inxpress_shipping_rates_zone']['all'] = $this->request->post['shipping_inxpress_shipping_rates_zone_all'];
		} else {
			$data['shipping_inxpress_shipping_rates_zone']['all'] = $this->config->get('shipping_inxpress_shipping_rates_zone_all');
		}

		foreach ($geo_zones as $geo_zone) {
			if (isset($this->request->post['shipping_inxpress_shipping_rates_zone_' . $geo_zone['geo_zone_id']])) {
				$data['shipping_inxpress_shipping_rates_zone'][$geo_zone['geo_zone_id']] = $this->request->post['shipping_inxpress_shipping_rates_zone_' . $geo_zone['geo_zone_id']];
			} else {
				$data['shipping_inxpress_shipping_rates_zone'][$geo_zone['geo_zone_id']] = $this->config->get('shipping_inxpress_shipping_rates_zone_' . $geo_zone['geo_zone_id']);
			}
		}

		$data['geo_zones'] = $geo_zones;

		if (isset($this->request->post['shipping_inxpress_shipping_rates_status'])) {
			$data['shipping_inxpress_shipping_rates_status'] = $this->request->post['shipping_inxpress_shipping_rates_status'];
		} else {
			$data['shipping_inxpress_shipping_rates_status'] = $this->config->get('shipping_inxpress_shipping_rates_status');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_sort_order'])) {
			$data['shipping_inxpress_shipping_rates_sort_order'] = $this->request->post['shipping_inxpress_shipping_rates_sort_order'];
		} else {
			$data['shipping_inxpress_shipping_rates_sort_order'] = $this->config->get('shipping_inxpress_shipping_rates_sort_order');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_city'])) {
			$data['shipping_inxpress_shipping_rates_city'] = $this->request->post['shipping_inxpress_shipping_rates_city'];
		} else {
			$data['shipping_inxpress_shipping_rates_city'] = $this->config->get('shipping_inxpress_shipping_rates_city');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_state'])) {
			$data['shipping_inxpress_shipping_rates_state'] = $this->request->post['shipping_inxpress_shipping_rates_state'];
		} else {
			$data['shipping_inxpress_shipping_rates_state'] = $this->config->get('shipping_inxpress_shipping_rates_state');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_country'])) {
			$data['shipping_inxpress_shipping_rates_country'] = $this->request->post['shipping_inxpress_shipping_rates_country'];
		} else {
			$data['shipping_inxpress_shipping_rates_country'] = $this->config->get('shipping_inxpress_shipping_rates_country');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_postcode'])) {
			$data['shipping_inxpress_shipping_rates_postcode'] = $this->request->post['shipping_inxpress_shipping_rates_postcode'];
		} else {
			$data['shipping_inxpress_shipping_rates_postcode'] = $this->config->get('shipping_inxpress_shipping_rates_postcode');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_dhl'])) {
			$data['shipping_inxpress_shipping_rates_dhl'] = $this->request->post['shipping_inxpress_shipping_rates_dhl'];
		} else {
			$data['shipping_inxpress_shipping_rates_dhl'] = $this->config->get('shipping_inxpress_shipping_rates_dhl');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_ups'])) {
			$data['shipping_inxpress_shipping_rates_ups'] = $this->request->post['shipping_inxpress_shipping_rates_ups'];
		} else {
			$data['shipping_inxpress_shipping_rates_ups'] = $this->config->get('shipping_inxpress_shipping_rates_ups');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_canpar'])) {
			$data['shipping_inxpress_shipping_rates_canpar'] = $this->request->post['shipping_inxpress_shipping_rates_canpar'];
		} else {
			$data['shipping_inxpress_shipping_rates_canpar'] = $this->config->get('shipping_inxpress_shipping_rates_canpar');
		}

		if (isset($this->request->post['shipping_inxpress_shipping_rates_purolator'])) {
			$data['shipping_inxpress_shipping_rates_purolator'] = $this->request->post['shipping_inxpress_shipping_rates_purolator'];
		} else {
			$data['shipping_inxpress_shipping_rates_purolator'] = $this->config->get('shipping_inxpress_shipping_rates_purolator');
		}

		$data['inxpress_shipping_store_id'] = $this->config->get('inxpress_shipping_store_id');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$data['version'] = VERSION;
		$data['base_url'] = HTTPS_SERVER;
		$data['callback_url'] = $this->url->link('extension/shipping/inxpress_shipping_rates/registered', 'user_token=' . $this->session->data['user_token'], true);

		$this->response->setOutput($this->load->view('extension/shipping/inxpress_shipping_rates', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/shipping/inxpress_shipping_rates')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}